//config.java Summer 2003
//Features:
// case sensitive
// [section] key=value
// section:key=value
//Q1 2004, argh my formatting/code layout was attrotious
//Fixed white space around keys

import java.io.*;
import java.util.Hashtable;

public class config
{
	static final int version = 5;
	static Hashtable settings;

	public config()
	{
		//System.out.println("I <config> Loading v" + version);
		settings = new Hashtable(2);
		
		//System.err.println("D <config> Loaded v" + version);
	}

//
// Load
//

	public void readConfig(String filename)
	{
		String thisSection=null, hash;
		String line="", section, key, value;
		int equal, colon;
		int lBkt, rBkt;
		Reader in;
		
		try
		{
			in = new FileReader( filename );
		}
		catch(IOException e)
		{
			System.out.println("E <config> " + e.getMessage());
			return;
		}
		BufferedReader file = new BufferedReader( in );

    while(true)
    {
      try
      {
        if (file.ready())
          line = file.readLine().trim();
        else
          break;
      } catch(IOException e)
      {
        System.out.println(e.getMessage());
        break;
      }

      if (line.length() < 3) continue;
      if (line.startsWith(";")) continue;
      if (line.startsWith("#")) continue;
      if (line.startsWith("//")) continue;

      equal = line.indexOf("=");
      colon = line.indexOf(":");

      if (colon > 0 && equal > colon + 1)
      {
        section = line.substring(0, colon).trim();
        key = line.substring(colon+1, equal).trim();
        value = line.substring(equal+1, line.length()).trim();

        hash = section + ":" + key;
        if (settings.get(hash) != null)
          settings.remove(value);
        settings.put(hash, value);
        continue;
      }

      lBkt = line.indexOf("[");
      rBkt = line.indexOf("]");

      if (rBkt > lBkt + 1)
      {
        thisSection = line.substring(lBkt+1, rBkt).trim();
        continue;
      }

      if (thisSection == null || thisSection.length() < 1) continue;
      if (equal < 1) continue;

      key = line.substring(0, equal).trim();
      value = line.substring(equal+1, line.length()).trim();

      hash = thisSection + ":" + key;
      if (settings.get(hash) != null)
        settings.remove(value);
      settings.put(hash, value);
    }
  }

//
// Get
//

	public String GetStr(String section, String key)
	{
		String str = (String)settings.get(section + ":" + key);
		return str;
	}

	public int GetInt(String section, String key, int def)
	{
		String str = GetStr(section, key);
		if (str == null) return def;
		return Integer.parseInt( str );
	}
}
